/;; Copyright 2009, 2019 Kevin Ryde.

;; This file is part of aumix-mode.
;;
;; aumix-mode is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by the
;; Free Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; aumix-mode is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
;; Public License for more details.
;;
;; You should have received a copy of the GNU General Public License along
;; with aumix-mode; see the file COPYING.  Failing that, go to
;; <http://www.gnu.org/licenses/>.


(progn
  (add-to-list 'load-path (expand-file-name ".."))
  (autoload 'aumix "aumix-mode" nil t)

  (let ((frame (make-frame '((width  . 80)
                             (height . 15)
                             ;; (font . "5x8")
                             (font . "6x10")
                             ))))
    (select-frame-set-input-focus frame)
    (aumix)
    (sit-for 1)
    (sit-for 1)
    (sit-for 1)
    (sit-for 1)

    (shell-command (format "xwd -id %s >/tmp/d-aumix-mode--screenshot.xwd"
                           (frame-parameter nil 'outer-window-id)))
    (aumix-quit)
    (delete-frame frame)

    (shell-command "
convert -strip /tmp/d-aumix-mode--screenshot.xwd \
               /tmp/d-aumix-mode--screenshot.png;
pngtextadd --keyword=Title --text='aumix-mode.el screenshot' \
    /tmp/d-aumix-mode--screenshot.png;
pngtextadd --keyword=Author --text='Kevin Ryde' \
    /tmp/d-aumix-mode--screenshot.png;
pngtextadd --keyword=Copyright --text='Copyright 2009, 2019 Kevin Ryde'
    /tmp/d-aumix-mode--screenshot.png;
pngtextadd --keyword=Homepage --text='http://user42.tuxfamily.org/aumix-mode/index.html' \
    /tmp/d-aumix-mode--screenshot.png;
pngtextadd --keyword=Software --text='Generated by d-aumix-mode--screenshot.el, imagemagic and pngtextadd.' \
    /tmp/d-aumix-mode--screenshot.png;
pngtextadd --keyword=Description --text='A sample screenshot of aumix-mode.el running the aumix program in an Emacs buffer.' \
    /tmp/d-aumix-mode--screenshot.png;
")
    (shell-command
     (format "pngtextadd --keyword='Creation Time' --text='%s' \
                  /tmp/d-aumix-mode--screenshot.png"
             (format-time-string "%a, %d %b %Y %H:%M:%S %z")))

    (require 'imagetext)
    (add-hook 'image-mode-hook 'imagetext-show)

    (find-file "/tmp/d-aumix-mode--screenshot.png")))


(setq foo (frame-parameters nil))
