;; Copyright 2009, 2010, 2013, 2014, 2019 Kevin Ryde.

;; This file is part of aumix-mode.
;;
;; aumix-mode is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by the
;; Free Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; aumix-mode is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
;; Public License for more details.
;;
;; You should have received a copy of the GNU General Public License along
;; with aumix-mode; see the file COPYING.  Failing that, go to
;; <http://www.gnu.org/licenses/>.


;;-----------------------------------------------------------------------------
;; in non-existent directory

(with-temp-buffer
  (setq default-directory "/no/such/dir/exists")
  (aumix))


;;-----------------------------------------------------------------------------
;; customize

(customize-group 'multimedia)
(customize-group 'aumix-mode)


;;-----------------------------------------------------------------------------

(progn
  (load-file (expand-file-name "../aumix-mode.el"))
  (aumix))
(add-hook 'aumix-mode-hook 'error)
(remove-hook 'aumix-mode-hook 'error)
aumix-mode-hook
turn-on-font-lock

;;-----------------------------------------------------------------------------
;; LANGUAGE variations

(setenv "LANGUAGE" "en_AU:en_GB:en")
(setenv "LANGUAGE" "de")

(setq aumix-mode-switches nil)
(setq aumix-mode-switches '("-C" "xterm"))
(setq aumix-mode-switches '("-C" "vt100"))
(setq aumix-mode-switches '("-C" "ansi"))
(aumix)

;;-----------------------------------------------------------------------------
;; desktop.el

(progn
  ;; (load-file (expand-file-name "../aumix-mode.el"))
  (aumix)
  (switch-to-buffer "*aumix*")
  (rename-buffer "*auuu")
  (desktop-save "/tmp" t)
  (kill-buffer "*auuu")
  (desktop-read "/tmp")
  )

(with-current-buffer "*aumix*"
  (set (make-local-variable 'desktop-save-buffer)
       'ignore))

(desktop-save "/tmp")
(desktop-read "/tmp")
(desktop-clear)

;; /usr/share/emacs/24.3/lisp/info.el.gz

(progn
  (if (get-buffer "*foo*") (kill-buffer "*foo*"))
  ;; (get-buffer-create "*foo*")
  ;; (term-check-proc (get-buffer-create "*foo*"))
  (let ((process-environment (copy-sequence process-environment)))
    (setenv "DISPLAY" nil)
    (switch-to-buffer (make-term "aumix" "aumix" nil))
    (aumix-mode)))

(aumix-mode-make-term "foo")

(progn
  (switch-to-buffer (get-buffer-create "*aumix*"))
  (aumix-mode))


;;-----------------------------------------------------------------------------
(progn
  (add-to-list 'load-path (expand-file-name "~/lisp"))
  (autoload 'aumix "aumix-mode" nil t)
  (setq term-term-name "vt100")
  (aumix))


(term-set-escape-char ?\C-c)

(progn
  (switch-to-buffer (make-term "sh" "sh"))
  (term-char-mode))
(progn 
  (switch-to-buffer (make-term "sh" "sh"))
  (foo-mode))

(require 'term)
(define-key term-mode-map "\M-x")
(progn
  (switch-to-buffer (make-term "ninvaders" "ninvaders"))
  (term-char-mode))

(switch-to-buffer (make-term "ninvaders" "ninvaders"))

(define-derived-mode foo-mode term-mode "Foo"
  "docstring"
  (term-exec (current-buffer) "aumix" "aumix" nil nil)
  (term-char-mode))
(progn
  (switch-to-buffer "xx")
  (foo-mode))

;;-----------------
;; compile

(progn
  (add-to-list 'load-path (expand-file-name "."))
  (require 'my-byte-compile)
  (my-byte-compile))
(progn
  (add-to-list 'load-path (expand-file-name "."))
  (require 'my-byte-compile)
  (my-show-autoloads))


;;-----------------
;; clone-buffer not working ...

  (condition-case nil (term-kill-subjob) (error nil))
  (erase-buffer)
  (term-exec (current-buffer) "aumix" "aumix" nil nil)


;;-----------------

;; (setq aumix-mode-map (make-sparse-keymap "Aumix"))
;; (dolist (key '("\C-x" "\C-h"))
;;   (define-key aumix-mode-map key (lookup-key global-map key)))

;; (defadvice term-send-raw (around aumix activate)
;;   ""
;;   (unless (let ((cmd (lookup-key aumix-mode-map (this-command-keys))))
;;             (when cmd
;;               (message "%S %S" (this-command-keys) cmd)
;;               (command-execute cmd)
;;               t)))
;;   ad-do-it)
;; 
;;   ;;  (setq term-old-mode-map term-mode-map)
;;   ;;   
;;   ;;   



(define-key global-map [f11]
  (lambda ()
    (interactive)
    (message "key %S %S"
             (lookup-key (current-local-map) "\C-x")
             (eq aumix-mode-map (current-local-map)))))

;; (lookup-key term-raw-map "\C-x")
;; (lookup-key aumix-mode-map "\C-x")
;; (lookup-key global-map "\C-x")

;;   (term-mode)
;;   (term-char-mode)
;;   (switch-to-buffer "*terminal*"))


      ;; (term "aumix")
;; (setq term-term-name "linux")
;; (setq term-term-name "eterm-color")
;; (term "aumix")


;; (defun aumix-term-type-known-p (type)
;;   "Return non-nil if TYPE is a known terminal type.
;; TYPE is a possible string setting for the TERM environment
;; variable.  Currently it's checked by running the \"setterm\"
;; program."
;;   (equal 0 (call-process "setterm" nil nil nil "-term" type)))
;; 
;; (require 'cl)
;;
;; (defun aumix-choose-term-name ()
;;   (or (member-if 'aumix-term-type-known-p (list term-term-name
;;                                                 "linux"
;;                                                 "vt100"))
;;       term-term-name))
;;     (let ((term-term-name (aumix-choose-term-name)))


;; (aumix-term-type-known "eterm-color")
;; (aumix-term-type-known "vt100")
;; (aumix-term-type-known "linux")
;; (aumix-term-type-known "djskf")

;;       (add-to-list 'term-exec-hook 'aumix-kill-without-query)

;; (process-environment (copy-sequence process-environment))
;;           ;; (setenv "TERM" "linux")
          
  ;; TERM=linux works, colour drawing not quite right

;;   ;; doesn't know colours ...
;;   '(let ((process-environment (copy-sequence process-environment)))
;;      (setenv "TERM" "linux")
;;      (terminal-emulator "*aumix*" "aumix" nil 80 24))


;; (setq term-term-name "vt100")

;; no good as TERM=linux
;; (terminal-emulator "*aumix*" "env" '("TERM=linux" "aumix") 80 24)

;; arrow keys don't work
;; (term "aumix")



;;-----------------------------------------------------------------------------
;; unused bits

(defun aumix-unique-name ()
  "An internal part of aumix-mode.el.
Return a string \"aumix-temp-123\" for which there is no existing
buffer called \"*aumix-temp-123*\"."
  (let ((num 0)
        name)
    (while (get-buffer (concat "*" (setq name (format "aumix-temp-%d" num))
                               "*"))
      (setq num (1+ num)))
    name))

    ;; aumix-unique-name

    (let ((got  (aumix-unique-name))
          (want "aumix-temp-0"))
      (unless (equal got want)
        (error "aumix-unique-name got %S want %S" got want)
        (setq count (1+ count))))

    (progn
      (get-buffer-create "*aumix-temp-0*")
      (get-buffer-create "*aumix-temp-1*")
      (let ((got  (aumix-unique-name))
            (want "aumix-temp-2"))
        (unless (equal got want)
          (error "aumix-unique-name got %S want %S" got want)))
      (kill-buffer "*aumix-temp-0*")
      (kill-buffer "*aumix-temp-1*")
      (setq count (1+ count)))

(defvar aumix-mode-map-initialized nil
  "Non-nil after  `aumix-mode-map' parent keymap has been setup.")

